#include <string.h>
#include <stdio.h>
#include <jcode.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/X.h>
#include <X11/keysym.h>
#include <X11/Xlocale.h>
#include "TPager.h"
#include "getstr.h"

TPager(Display *display, struct PAGER *Pager, struct SCROLL *Scroll, XEvent *event)
{
	int				i, j, k;

	KeySym			key;			/* 줿key symbol */
	XComposeStatus	status;			/* XLookupStringΰ */

	XIC				ic;
	XIMStyle		style;

	Time			stime;			/* ֥륯åȽ */

	unsigned char	buf[256];
	int 			TempStrlen;

	int				ShiftPressFlg = 0;
	int				ButtonPressFlg = 0;
	int				ButtonPressCount = 0;


	CutNoExpose(display);

	if (event->xany.window != Pager->window) return;

	if (event->type == KeyRelease){
		XLookupString(event, buf, 10, &key, &status);
		if (key == XK_Shift_L || key == XK_Shift_R){
			ShiftPressFlg = 0;
		}
		return;
	}

	if (event->type == ButtonRelease){
		ButtonPressFlg = 0;
		return;
	}

	/* GraphicsExpose ٥Ȥν */
	if (event->type == GraphicsExpose){
		/*
		XRaiseWindow(display, window_p);
		*/
		return;
	}

	/* EXPOSE ٥Ȥν() */
	if (event->type == Expose){
		DrawWindow(display, Pager, Scroll);
		return;
	}

	if (event->type == ClientMessage){
		if (event->xclient.message_type == XInternAtom(display, "Pager-line", False)){
			Pager->pos = event->xclient.data.l[0];
			DrawWindow(display, Pager, Scroll);
			return;
		}
		if (event->xclient.message_type == XInternAtom(display, "Pager-scroll", False)){
			if (event->xclient.data.l[0] > 0) SCRLUP(display, Pager, Scroll);
			if (event->xclient.data.l[0] < 0) SCRLDOWN(display, Pager, Scroll);
			return;
		}
		if (event->xclient.message_type == XInternAtom(display, "Pager-HalfPage", False)){
			if (event->xclient.data.l[0] > 0) HALFPAGEUP(display, Pager, Scroll);
			if (event->xclient.data.l[0] < 0) HALFPAGEDOWN(display, Pager, Scroll);
			return;
		}
		if (event->xclient.message_type == XInternAtom(display, "Pager-Page", False)){
			if (event->xclient.data.l[0] > 0) PAGEUP(display, Pager, Scroll);
			if (event->xclient.data.l[0] < 0) PAGEDOWN(display, Pager, Scroll);
			return;
		}
		if (event->xclient.message_type == XInternAtom(display, "Pager-AllDraw", False)){
			DrawWindow(display, Pager, Scroll);
			return;
		}
	}

	if (event->type == KeyPress){
		XLookupString(event, buf, 10, &key, &status);

		/* 줿ᥤδؿ */
		SendXK(display, Pager->window, key);
		
		/* ν(scroll up) */
		if (key == XK_Down && event->xkey.state == 0){
			SCRLUP(display, Pager, Scroll);
			return;
		}

		/* ν(scroll down) */
		if (key == XK_Up && event->xkey.state == 0){
			SCRLDOWN(display, Pager, Scroll);
			return;
		}

		/* ν(1 page up) */
		if (key == XK_Right && event->xkey.state == 0){
			PAGEUP(display, Pager, Scroll);
			return;
		}

		/* ν(1 page up) */
		if (key == XK_Left && event->xkey.state == 0){
			PAGEDOWN(display, Pager, Scroll);
			return;
		}

		/* Shiftν(scroll up) */
		if (key == XK_Down && event->xkey.state == ShiftMask){
			ShiftPressFlg = 1;
			return;
		}

		/* Shiftν(scroll down) */
		if (key == XK_Up && event->xkey.state == ShiftMask){
			ShiftPressFlg = -1;
			return;
		}

		/* CTRL+Lν() */
		if ((key == XK_L || key == XK_l) && event->xkey.state == ControlMask){
			DrawWindow(display, Pager, Scroll);
			return;
		}

		if ((key >= XK_F1 && key <= XK_F10) && event->xkey.state == 0){
			SendChangeText(display, Pager, key - XK_F1);
			return;
		}

		/* Q keyν(quit) */
		if (key == XK_Q || key == XK_q){
			SendExit(display, Pager->window);
			return;
		}

		/* Return keyν */
		if (key == XK_Return){
			SendReturn(display, Pager->window);
			return;
		}

		return;
	}
}

#if undef
		if (key == XK_f){
			GetWinXY(&i, &j, 300, 2*(Pager->SIZE_Y+5)+10);
			XMoveWindow(display, win_search_p, i, j);
			XWarpPointer(display, None, win_search, 0, 0, 0, 0, 280/2, (Pager->SIZE_Y+5)/2);
			XMapRaised(display, win_search_p);
			XMapWindow(display, win_search);
			XSetInputFocus(display, win_search, RevertToNone, CurrentTime);
			XmbDrawString(display, win_search_p, MenuFS, TitlGC, 1, MEN_SIZE_X*2+5, "ʸϤƲ", 24);

			strbuf = getstr(display, win_search_p, win_search, MenuFS, TitlGC, 5, 20, MEN_SIZE_X, MEN_SIZE_X*2, ic, style, TitlFG, TitlBG, Pager->InputMode);
			if (strbuf != NULL){
				i = 1;
				while (Pager->pos+i < MAXLINE){
					if (NULL == Pager->buff[Pager->pos+i]) break;

					sjistoeuc(buf, 255, Pager->buff[Pager->pos+i], strlen(Pager->buff[Pager->pos+i]));
					if (NULL != strstr(buf, strbuf)){
						Pager->pos = Pager->pos + i;
						break;
					}
					i++;
				}
			}
			XUnmapWindow(display, win_search_p);
			XSetInputFocus(display, window_p, RevertToNone, CurrentTime);
			AllDraw(file_last_no, titlemes, file_no);
			SendDrawScrlbar(display, Pager);
		}

		if (key == XK_n){
			i = 1;
			while (Pager->pos+i < MAXLINE){
				if (NULL == Pager->buff[Pager->pos+i]) break;

				sjistoeuc(buf, 255, Pager->buff[Pager->pos+i], strlen(Pager->buff[Pager->pos+i]));
				if (NULL != strstr(buf, strbuf)){
					Pager->pos = Pager->pos + i;
					break;
				}
				i++;
			}
			AllDraw(file_last_no, titlemes, file_no);
			SendDrawScrlbar(display, Pager);
		}


		if (key == XK_b){
			i = 1;
			while (Pager->pos-i > 0){
				if (NULL == Pager->buff[Pager->pos-i]) break;

				sjistoeuc(buf, 255, Pager->buff[Pager->pos-i], strlen(Pager->buff[Pager->pos-i]));
				if (NULL != strstr(buf, strbuf)){
					Pager->pos = Pager->pos - i;
					break;
				}
				i++;
			}
			AllDraw(file_last_no, titlemes, file_no);
			SendDrawScrlbar(display, Pager);
		}
		/* CTRL+Sν(ѹ) */
	if ((key == XK_S || key == XK_s) && event->xkey.state == ControlMask){
		switch (Pager->SIZE_X){
			case	 7:		Pager->SIZE_X =  8;
							break;
			case	 8:		Pager->SIZE_X = 10;
							break;
			case	10:		Pager->SIZE_X = 12;
							break;
			case	12:		Pager->SIZE_X =  7;
							break;
		}
	}
#endif


SCRLUP(Display *display, struct PAGER *Pager, struct SCROLL *Scroll)
{
	char buf[256];

	if (Pager->pos+Pager->LINES+1>Pager->lines){
		Bell(display, Pager->window, Pager->BELL);
		return 1;
	}
	Pager->pos++;
	XCopyArea(display, Pager->window, Pager->window, Pager->gc, 0, Pager->SIZE_Y, Pager->Win_Wid, Pager->Win_Heit-Pager->SIZE_Y,0,0,1);
	XClearArea(display, Pager->window, 0, Pager->Win_Heit-Pager->SIZE_Y, Pager->Win_Wid, Pager->SIZE_Y, False);



/*
	if (strlen(Pager->buff[Pager->pos+Pager->LINES-1]) == 0) buf[0] = 0;
	else sjistoeuc(buf, 255, Pager->buff[Pager->pos+Pager->LINES-1],strlen(Pager->buff[Pager->pos+Pager->LINES-1]));
	XmbDrawString(display, Pager->window, Pager->fs, Pager->gc, 0, Pager->LINES*Pager->SIZE_Y-2, buf, strlen(buf)-1);
*/
	if (strlen(Pager->buff[Pager->pos+Pager->LINES-1]) == 0) buf[0] = 0;
	XmbDrawString(display, Pager->window, Pager->fs, Pager->gc, 0, Pager->LINES*Pager->SIZE_Y-2, Pager->buff[Pager->pos+Pager->LINES-1], strlen(Pager->buff[Pager->pos+Pager->LINES-1])-1);



	SendDrawScrlbar(display, Pager);
	
	return 0;
}

SCRLDOWN(Display *display, struct PAGER *Pager, struct SCROLL *Scroll)
{
	char buf[256];
	if (Pager->pos <= 0){
		Bell(display, Pager->window, Pager->BELL);
		return 1;
	}
	Pager->pos--;
	XCopyArea(display, Pager->window, Pager->window, Pager->gc, 0, 0, Pager->Win_Wid, Pager->Win_Heit-Pager->SIZE_Y,0,Pager->SIZE_Y);
	XClearArea(display, Pager->window, 0, 0, Pager->Win_Wid, Pager->SIZE_Y, False);


/*
	if (strlen(Pager->buff[Pager->pos]) == 0) buf[0] = 0;
	else sjistoeuc(buf, 255, Pager->buff[Pager->pos],strlen(Pager->buff[Pager->pos]));
	XmbDrawString(display, Pager->window, Pager->fs, Pager->gc, 0, 1*Pager->SIZE_Y-2, buf, strlen(buf)-1);
*/
	if (strlen(Pager->buff[Pager->pos]) == 0) buf[0] = 0;
	XmbDrawString(display, Pager->window, Pager->fs, Pager->gc, 0, 1*Pager->SIZE_Y-2, Pager->buff[Pager->pos], strlen(Pager->buff[Pager->pos])-1);
	
	SendDrawScrlbar(display, Pager);
	return 0;	
}

PAGEUP(Display *display, struct PAGER *Pager, struct SCROLL *Scroll)
{
	int j;

	if (Pager->lines<Pager->LINES){
		Bell(display, Pager->window, Pager->BELL);
		return;
	}
	if ( Pager->pos + 2*Pager->LINES > Pager->lines){
		if (Pager->pos + Pager->LINES == Pager->lines){
			Bell(display, Pager->window, Pager->BELL);
			return;
		}
		Pager->pos = Pager->lines - Pager->LINES;
	}
	else Pager->pos+=(Pager->LINES);

	DrawWindow(display, Pager, Scroll);
}

PAGEDOWN(Display *display, struct PAGER *Pager, struct SCROLL *Scroll)
{
	int j;

	if (Pager->pos - Pager->LINES < 0){
		if (Pager->pos == 0){
			Bell(display, Pager->window, Pager->BELL);
			return;
		}
		Pager->pos=0;
	}
	else Pager->pos -= Pager->LINES;

	DrawWindow(display, Pager, Scroll);
}

HALFPAGEDOWN(Display *display, struct PAGER *Pager, struct SCROLL *Scroll)
{
	int j;

	if (Pager->pos-(Pager->LINES*HALFPER/100) < 0){
		if (Pager->pos == 0){
			Bell(display, Pager->window, Pager->BELL);
			return;
		}
		Pager->pos = 0;
	}
	else Pager->pos-=(Pager->LINES*HALFPER/100);
	DrawWindow(display, Pager, Scroll);
}

HALFPAGEUP(Display *display, struct PAGER *Pager, struct SCROLL *Scroll)
{
	int j;

	if (Pager->lines<Pager->LINES){
		Bell(display, Pager->window, Pager->BELL);
		return;
	}
	if (Pager->pos+Pager->LINES-1+(Pager->LINES*HALFPER/100) > Pager->lines){
		if (Pager->pos+Pager->LINES == Pager->lines){
			Bell(display, Pager->window, Pager->BELL);
			return;
		}
		Pager->pos = Pager->lines - Pager->LINES;
	}
	else Pager->pos+=(Pager->LINES*HALFPER/100);
	DrawWindow(display, Pager, Scroll);
}



DrawWindow(Display *display, struct PAGER *Pager, struct SCROLL *Scroll)
{
	int				i;
	unsigned char	buf[512];

	XClearWindow(display, Pager->window);
	for (i = 0 ; i <= Pager->LINES-1 ; i++){


/*
		if (strlen(Pager->buff[Pager->pos+i]) == 0){
			buf[0] = ' ';
			buf[1] = ' ';
			buf[2] = 0;
		} else{
			sjistoeuc(buf, 255, Pager->buff[Pager->pos+i],strlen(Pager->buff[Pager->pos+i]));
		}

		XmbDrawString(display, Pager->window, Pager->fs, Pager->gc, 0, (i+1)*Pager->SIZE_Y-2, buf, strlen(buf)-1);
*/
		if (strlen(Pager->buff[Pager->pos+i]) == 0){
			buf[0] = ' ';
			buf[1] = ' ';
			buf[2] = 0;
			XmbDrawString(display, Pager->window, Pager->fs, Pager->gc, 0, (i+1)*Pager->SIZE_Y-2, buf, strlen(buf)-1);
		} else{
		XmbDrawString(display, Pager->window, Pager->fs, Pager->gc, 0, (i+1)*Pager->SIZE_Y-2, Pager->buff[Pager->pos+i], strlen(Pager->buff[Pager->pos+i])-1);
		}




	}
	SendDrawScrlbar(display, Pager);
	return;
}

CutNoExpose(Display *display)
{
	XEvent	event;

	while(XPending(display) >= 1){
		XPeekEvent(display, &event);
		if (event.type == NoExpose){
			XNextEvent(display, &event);
			continue;
		}else{
			break;
		}
	}
}

