#include <string.h>
#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xlocale.h>
#include "rman.h"
#include "TPager.h"
#include "getstr.h"

#define screenNumber    DefaultScreen(RMan.display)
#define rootWindow      RootWindow(RMan.display,screenNumber)
#define blackPixel      BlackPixel(RMan.display,screenNumber)
#define whitePixel      WhitePixel(RMan.display,screenNumber)
#define defaultDepth    DefaultDepth(RMan.display, 0)

struct PAGER		Pager;
struct SCROLL		Scroll;
struct MENUWIN		MenuWin;
struct RMAN			RMan;
struct FontNameSet	FNSet[5];
struct FileSet		FSet[20];
struct MENU			Menu[21];

void main(int argc, char *argv[])
{

	int				i, j, k;

	unsigned char	disbuf[80], *disname = (unsigned char *) &disbuf[0];

	XEvent			event;			/* ٥ȹ¤ */

	XIC				ic;
	XIMStyle		style;

	unsigned char	cfgname[80];	/* ĿͤΥե졼ե̾ */
	unsigned char	rootcfgname[80];/* ̤Υե졼ե̾ */

	RMan.MaxLine = MAXLINE;

/*
	XSetErrorHandler(ehandler);
*/
	setlocale(LC_ALL, "");
	if (XSupportsLocale() == False) exit(1);

	/* ǥեȤΥե졼ե̾ */
	GetCfgName(cfgname, rootcfgname);

	/* -display -cfg -rcfgץɤ߹ */
	GetOption1(argc, argv, disname, cfgname, rootcfgname);

	/* ǥץ쥤Υץ */
	if (!(RMan.display = XOpenDisplay(disname))){
		fprintf(stderr, "ǥץ쥤򥪡ץǤޤ\n");
		exit(2);
	}
	/*
	XSynchronize(RMan.display, True);
	*/

	/* եȡɤ߹ */
	ReadConfigFile(rootcfgname);
	ReadConfigFile(cfgname);

	/*  */
	SetColor();

	/* -sizeץɤ߹ */
	GetOption2(argc, argv);

	/*  Window κ  */
	CreateWindow();

	/*  Window Manager ؤ  */
	SetWinMan(argc, argv); 

	/*  GC  &   */
	CreateSetGC();

	/*  Pixmap  */
	CreatePixmap();

	/*  WindowMap  */
	MapWindow();

	/*  ٥  */
	SetEvent();

	/*  եȥåȤκ  */
	SetFontSet(RMan.display, RMan.ANK_FONT, RMan.KANJI_FONT, &(Pager.fs));
	SetFontSet(RMan.display, RMan.MENU_ANK, RMan.MENU_KANJI, &(MenuWin.fs));

	/*  MENU_ANKβ  */
	RMan.MEN_SIZE_X = GetFontSize(RMan.display, RMan.MENU_ANK);

	/*  Window Manager ؤ  */
	SetWinMan(argc, argv); 

	if ( 0 != SetJapan(RMan.display, RMan.search, &ic, &style, Pager.fs)){
		Pager.InputMode = ANK;
	}else{
		Pager.InputMode = KANJI;
	}

	/* config fileɤ߹2 */
	ReadConfigFile2(rootcfgname, ":root", &(MenuWin.file_last_no), MenuWin.titlemes);

	MenuWin.file_no = 0;
	Pager.pos = 0;

	Initialize(RMan.display, &Pager, &Scroll, &MenuWin, &RMan, Menu, FSet);

	while(1){
		/*
		if (XPending(RMan.display) == 0){
			
		}
		*/
		XNextEvent(RMan.display, &event);
		Main(RMan.display, &Pager, &Scroll, &MenuWin, &event, Menu, FSet, rootcfgname, &RMan);
		TPager(RMan.display, &Pager, &Scroll, &event);
		TScrlbar(RMan.display, &Pager, &Scroll, &event);
		TMenu(RMan.display, &Pager, &MenuWin, Menu, &event);
	}
}

CreateWindow()
{
	int i, j;
	XSetWindowAttributes	att;

	Pager.Win_Wid = Pager.SIZE_X * Pager.LINELEN;
	Pager.Win_Heit = (Pager.SIZE_Y)*Pager.LINES + 1;
	Scroll.ScrlWid = SCRL_WID;
	RMan.WINP_HEIT = (Pager.Win_Heit+MENP_HEIT+2) - 1;
	RMan.WINP_WID  = (Pager.Win_Wid+Scroll.ScrlWid+2);
	Scroll.ScrlHeit = (RMan.WINP_HEIT-MENP_HEIT-BOX_HEIT*4-SCRL_BOR * 2*5-8);
	Scroll.ScrlBoxWid = BOX_WID;
	Scroll.ScrlBoxHeit = BOX_HEIT;


	RMan.window_p = XCreateSimpleWindow(RMan.display, rootWindow,
					WINP_X,  WINP_Y,
					RMan.WINP_WID, RMan.WINP_HEIT, 1, blackPixel, blackPixel);
	Pager.window = XCreateSimpleWindow(RMan.display, RMan.window_p,
					WIN_X, WIN_Y,
					Pager.Win_Wid, Pager.Win_Heit, 0,
					RMan.MainFG, RMan.MainBG);
	RMan.scrbar_p = XCreateSimpleWindow(RMan.display, RMan.window_p,
					SCRP_X, SCRP_Y,
					SCRP_WID, SCRP_HEIT, 1,
					Scroll.ScrlFG, Scroll.ScrlFG);
	Scroll.scrbar = XCreateSimpleWindow(RMan.display, RMan.scrbar_p,
					SCRL_X, SCRL_Y,
					Scroll.ScrlWid+SCRL_BOR*2, Scroll.ScrlHeit+2, 0,
					Scroll.ScrlBG, Scroll.ScrlBG);
	Scroll.scrbar_box = XCreateSimpleWindow(RMan.display, Scroll.scrbar,
					BOX_X, BOX_Y,
					Scroll.ScrlBoxWid+SCRL_BOR*2, Scroll.ScrlBoxHeit, 0,
					Scroll.ScrlFG, Scroll.ScrlFG);
	Scroll.scrbar_up = XCreateSimpleWindow(RMan.display, Scroll.scrbar,
					0, 0,
					Scroll.ScrlWid, 1, 0,
					Scroll.ScrlBG, Scroll.ScrlBG);
	Scroll.scrbar_down = XCreateSimpleWindow(RMan.display, Scroll.scrbar,
					0, 0,
					Scroll.ScrlWid, 1, 0,
					Scroll.ScrlBG, Scroll.ScrlBG);
	Scroll.win_up1 = XCreateSimpleWindow(RMan.display, RMan.scrbar_p,
					UP1_X, UP1_Y,
					UP1_WID, UP1_HEIT, 1,
					Scroll.ScrlBG, Scroll.ScrlBG);
	Scroll.win_up2 = XCreateSimpleWindow(RMan.display, RMan.scrbar_p,
					UP2_X, UP2_Y,
					UP2_WID, UP2_HEIT, 1,
					Scroll.ScrlBG, Scroll.ScrlBG);
	Scroll.win_down1 = XCreateSimpleWindow(RMan.display, RMan.scrbar_p,
					DOWN1_X, DOWN1_Y,
					DOWN1_WID, DOWN1_HEIT, 1,
					Scroll.ScrlBG, Scroll.ScrlBG);
	Scroll.win_down2 = XCreateSimpleWindow(RMan.display, RMan.scrbar_p,
					DOWN2_X, DOWN2_Y,
					DOWN2_WID, DOWN2_HEIT, 1,
					Scroll.ScrlBG, Scroll.ScrlBG);
	MenuWin.exit = XCreateSimpleWindow(RMan.display, RMan.window_p,
					EXT_X+1, EXT_Y+1,
					EXT_WID, EXT_HEIT, MEN_BOR,
					MenuWin.ExitBG, MenuWin.ExitBG);
	RMan.search_p = XCreateSimpleWindow(RMan.display, rootWindow,
					0, 0,
					300, 2*(Pager.SIZE_Y+5)+10, 1,
					MenuWin.TitlFG, MenuWin.TitlBG);
	RMan.search = XCreateSimpleWindow(RMan.display, RMan.search_p,
					10, Pager.SIZE_Y+10,
					280, Pager.SIZE_Y+5, 1,
					MenuWin.TitlFG, MenuWin.TitlBG);

	/* ɥޥ͡β˻ */
	att.override_redirect = True;
	XChangeWindowAttributes(RMan.display, RMan.search_p,
					CWOverrideRedirect, &att);
	
	MenuWin.title = XCreateSimpleWindow(RMan.display, RMan.window_p,
					EXT_X+EXT_WID+(MEN_BOR+1)*2, EXT_Y+1,
					RMan.WINP_WID-EXT_WID-2, EXT_HEIT, MEN_BOR,
					MenuWin.TitlBG, MenuWin.TitlBG);
	
	for ( i = 0 ; i <= MenuWin.YY-1 ; i++ ){
		for ( j = 0 ; j <= MenuWin.XX-2 ; j++ ){
			MenuWin.sw[i*MenuWin.XX+j] = XCreateSimpleWindow(
						RMan.display, RMan.window_p,
						(MEN_WID+(MEN_BOR+1)*2)*j,
						(MEN_HEIT+(MEN_BOR+1)*2)*i+EXT_HEIT+(MEN_BOR+1)*2,
						MEN_WID, MEN_HEIT, MEN_BOR, MenuWin.BG, MenuWin.BG);
		}
		MenuWin.sw[i*MenuWin.XX+MenuWin.XX-1] = XCreateSimpleWindow(
						RMan.display, RMan.window_p,
						(MEN_WID+(MEN_BOR+1)*2)*(MenuWin.XX-1),
						(MEN_HEIT+(MEN_BOR+1)*2)*i+EXT_HEIT+(MEN_BOR+1)*2,
						RMan.WINP_WID-(4+MEN_WID)*(MenuWin.XX-1), MEN_HEIT,
						MEN_BOR, MenuWin.BG, MenuWin.BG);
	}
}


ChangeWindow()
{
	int i, j;

	Pager.Win_Wid = Pager.SIZE_X * Pager.LINELEN;
	Pager.Win_Heit = (Pager.SIZE_Y)*Pager.LINES + 1;
	Scroll.ScrlWid = SCRL_WID;
	Scroll.ScrlHeit = SCRL_HEIT;
	XMoveResizeWindow(RMan.display, RMan.scrbar_p,    SCRP_X,  SCRP_Y,  SCRP_WID,  SCRP_HEIT);
	XMoveResizeWindow(RMan.display, Scroll.scrbar,     SCRL_X,  SCRL_Y,  Scroll.ScrlWid,  Scroll.ScrlHeit);
	/*
	XMoveResizeWindow(RMan.display, scrbar_up,  0,       0,       SCRL_WID,  1);
	XMoveResizeWindow(RMan.display, scrbar_down,0,       0,       SCRL_WID,  1);
	*/
	XMoveResizeWindow(RMan.display, Scroll.win_up1,    UP1_X,   UP1_Y,   UP1_WID,   UP1_HEIT);
	XMoveResizeWindow(RMan.display, Scroll.win_up2,    UP2_X,   UP2_Y,   UP2_WID,   UP2_HEIT);
	XMoveResizeWindow(RMan.display, Scroll.win_down1,  DOWN1_X, DOWN1_Y, DOWN1_WID, DOWN1_HEIT);
	XMoveResizeWindow(RMan.display, Scroll.win_down2,  DOWN2_X, DOWN2_Y, DOWN2_WID, DOWN2_HEIT);

	XResizeWindow(RMan.display, Pager.window,     Pager.Win_Wid,   Pager.Win_Heit);
	XResizeWindow(RMan.display, MenuWin.exit,   EXT_WID,   EXT_HEIT);

	XMoveResizeWindow(RMan.display, MenuWin.title, EXT_X+EXT_WID+(MEN_BOR+1)*2, EXT_Y+1, RMan.WINP_WID-EXT_WID, EXT_HEIT);

	for ( i = 0 ; i <= MenuWin.YY-1 ; i++ ){
		for ( j = 0 ; j <= MenuWin.XX-2 ; j++ ){
			XMoveResizeWindow(RMan.display, MenuWin.sw[i*MenuWin.XX+j],(MEN_WID+(MEN_BOR+1)*2)*j, (MEN_HEIT+(MEN_BOR+1)*2)*i+EXT_HEIT+(MEN_BOR+1)*2, MEN_WID, MEN_HEIT);
		}
		XMoveResizeWindow(RMan.display, MenuWin.sw[i*MenuWin.XX+MenuWin.XX-1], (MEN_WID+(MEN_BOR+1)*2)*(MenuWin.XX-1), (MEN_HEIT+(MEN_BOR+1)*2)*i+EXT_HEIT+(MEN_BOR+1)*2, RMan.WINP_WID-(MEN_WID+(MEN_BOR+1)*2)*(MenuWin.XX-1), MEN_HEIT);
	}
	SendDrawScrlbar(RMan.display, &Pager);
}

CreatePixmap()
{
	int		width, height, x, y;
	Pixmap	pp,	pixmap_bit = None;
	Pixmap	pixmap_up1, pixmap_up2, pixmap_down1, pixmap_down2, pixmap_exit;

	pixmap_up1   = XCreatePixmapFromBitmapData(RMan.display, Scroll.win_up1,   up1_bits,   16, 16, Scroll.ScrlFG, Scroll.ScrlBG, defaultDepth);
	pixmap_up2   = XCreatePixmapFromBitmapData(RMan.display, Scroll.win_up2,   up2_bits,   16, 16, Scroll.ScrlFG, Scroll.ScrlBG, defaultDepth);
	pixmap_down1 = XCreatePixmapFromBitmapData(RMan.display, Scroll.win_down1, down1_bits, 16, 16, Scroll.ScrlFG, Scroll.ScrlBG, defaultDepth);
	pixmap_down2 = XCreatePixmapFromBitmapData(RMan.display, Scroll.win_down2, down2_bits, 16, 16, Scroll.ScrlFG, Scroll.ScrlBG, defaultDepth);
	pixmap_exit  = XCreatePixmapFromBitmapData(RMan.display, MenuWin.exit,  exit_bits,  16, 16, MenuWin.ExitFG, MenuWin.ExitBG, defaultDepth);

	XSetWindowBackgroundPixmap(RMan.display, Scroll.win_up1, pixmap_up1);
	XSetWindowBackgroundPixmap(RMan.display, Scroll.win_up2, pixmap_up2);
	XSetWindowBackgroundPixmap(RMan.display, Scroll.win_down1, pixmap_down1);
	XSetWindowBackgroundPixmap(RMan.display, Scroll.win_down2, pixmap_down2);
	XSetWindowBackgroundPixmap(RMan.display, MenuWin.exit, pixmap_exit);

	XReadBitmapFile(RMan.display, RMan.window_p, RMan.Icon, &width, &height, &RMan.IconPixmap, &x, &y);

	if (BitmapSuccess != XReadBitmapFile(RMan.display, Pager.window, RMan.Bitmap, &width, &height, &pp, &x, &y)){
		pixmap_bit = None;
	}else{
		pixmap_bit = XCreatePixmap(RMan.display, Pager.window, width, height, defaultDepth);
		XCopyPlane(RMan.display, pp, pixmap_bit, Pager.BitmGC, 0, 0, width, height, 0, 0, 1);
		XSetWindowBackgroundPixmap(RMan.display, Pager.window, pixmap_bit);
	}
	XFreePixmap(RMan.display, pp);
}

MapWindow()
{
	XMapWindow(RMan.display,RMan.window_p);
	XMapSubwindows(RMan.display,RMan.window_p);
	XMapSubwindows(RMan.display,RMan.scrbar_p);
	XMapSubwindows(RMan.display,Scroll.scrbar);
	XRaiseWindow(RMan.display, Scroll.scrbar_box);
	XUnmapWindow(RMan.display, RMan.search);
}

ReadConfigFile(char *fname)
{
	FILE	*cfp;
	char	buf1[81], buf2[81], buf[81];
	int		Num;

	/* config fileΥץ */
	if (NULL == (cfp = fopen(fname, "rt"))){
		return;
	}

	/* config fileread */
	while (EOF != fscanf(cfp, "%s %s",buf1, buf2))
	{
		if (!strncmp(buf1,"FNS", 3)){
			Num = atoi(&buf1[3]);
			FNSet[Num].size = atoi(buf2);
			if (EOF == fscanf(cfp, "%s", buf1)) break;
			strcpy(FNSet[Num].KanjiFontName, buf1);
			if (EOF == fscanf(cfp, "%s", buf1)) break;
			strcpy(FNSet[Num].AnkFontName, buf1);
		}

		if (!strcmp(buf1, "MKANJI"))	MemStringCopy(&RMan.MENU_KANJI, buf2);
		if (!strcmp(buf1, "MANK"))		MemStringCopy(&RMan.MENU_ANK, buf2);
		if (!strcmp(buf1, "Bitmap"))	MemStringCopy(&RMan.Bitmap, buf2);
		if (!strcmp(buf1, "Icon"))		MemStringCopy(&RMan.Icon, buf2);
		if (!strcmp(buf1, "DEFSIZE")){
			switch (atoi(buf2)){
				case 14:	Pager.SIZE_X=7;
							break;
				case 20:	Pager.SIZE_X=10;
							break;
				case 24:	Pager.SIZE_X=12;
							break;
				default:	Pager.SIZE_X=8;
							break;
			}
			Pager.SIZE_Y = (Pager.SIZE_X*2 + Pager.SPACE_Y);
			Num = GetFontNoFromSize(FNSet, Pager.SIZE_X);
			RMan.KANJI_FONT = FNSet[Num].KanjiFontName;
			RMan.ANK_FONT   = FNSet[Num].AnkFontName;
		}
		if (!strcmp(buf1, "WINNAME"))	MemStringCopy(&RMan.winname, buf2);
		if (!strcmp(buf1, "SPACE_Y"))	Pager.SPACE_Y = atoi(buf2);
		if (!strcmp(buf1, "LINES"))		Pager.LINES = atoi(buf2);
		if (!strcmp(buf1, "LINELEN"))	Pager.LINELEN = atoi(buf2);
		if (!strcmp(buf1, "DBLCLK"))	Pager.DOUBLE_CLICK = atoi(buf2);
		if (!strcmp(buf1, "XX"))		MenuWin.XX = atoi(buf2);
		if (!strcmp(buf1, "YY"))		MenuWin.YY = atoi(buf2);
		if (!strcmp(buf1, "BELL"))		Pager.BELL = atoi(buf2);

		if (!strcmp(buf1, "MainFG"))	MemStringCopy(&RMan.MainFGName, buf2);
		if (!strcmp(buf1, "MenuFG"))	MemStringCopy(&RMan.MenuFGName, buf2);
		if (!strcmp(buf1, "TitlFG"))	MemStringCopy(&RMan.TitlFGName, buf2);
		if (!strcmp(buf1, "ScrlFG"))	MemStringCopy(&RMan.ScrlFGName, buf2);
		if (!strcmp(buf1, "MainBG"))	MemStringCopy(&RMan.MainBGName, buf2);
		if (!strcmp(buf1, "MenuBG"))	MemStringCopy(&RMan.MenuBGName, buf2);
		if (!strcmp(buf1, "TitlBG"))	MemStringCopy(&RMan.TitlBGName, buf2);
		if (!strcmp(buf1, "ScrlBG"))	MemStringCopy(&RMan.ScrlBGName, buf2);
		if (!strcmp(buf1, "BitmFG"))	MemStringCopy(&RMan.BitmFGName, buf2);

		if (!strcmp(buf1, "ENV")){
			if ( getenv(buf2) == NULL){
				if (RMan.ENV_NO > 9) RMan.ENV_NO = 0;
				fscanf(cfp, "%s", buf1);
				sprintf(buf, "%s=%s", buf2, buf1);
				MemStringCopy(&RMan.ENV[RMan.ENV_NO], buf);
				putenv(RMan.ENV[RMan.ENV_NO]);
				RMan.ENV_NO++;
			}
		}

		if (NULL == fgets(buf1, Pager.LINELEN + 1, cfp)) break;
	}
	fclose(cfp);
}


GetOption2(int argc, char *argv[])
{
	int		i;

	for ( i=1 ; i<=argc-1 ; i++ ){
		if (!strncmp(argv[i], "-size=", 6)){
			Pager.SIZE_X = atoi(&argv[i][6]) / 2;
			Pager.SIZE_Y = (Pager.SIZE_X*2 + Pager.SPACE_Y);
			RMan.KANJI_FONT = FNSet[GetFontNoFromSize(FNSet, Pager.SIZE_X)].KanjiFontName;
			RMan.ANK_FONT   = FNSet[GetFontNoFromSize(FNSet, Pager.SIZE_X)].AnkFontName;
		}
	}
}

SetEvent()
{
	int		i;
	XSelectInput(RMan.display, RMan.window_p, StructureNotifyMask);
	XSelectInput(RMan.display, Pager.window, KeyPressMask|KeyReleaseMask|ExposureMask);
	XSelectInput(RMan.display, Scroll.scrbar_up, ButtonPressMask|EnterWindowMask | LeaveWindowMask);
	XSelectInput(RMan.display, Scroll.scrbar_down, ButtonPressMask|EnterWindowMask | LeaveWindowMask);
	XSelectInput(RMan.display, Scroll.win_up1, ButtonPressMask|ButtonReleaseMask|ExposureMask|EnterWindowMask | LeaveWindowMask);
	XSelectInput(RMan.display, Scroll.win_up2, ButtonPressMask|ExposureMask|EnterWindowMask | LeaveWindowMask);
	XSelectInput(RMan.display, Scroll.win_down1, ButtonPressMask|ButtonReleaseMask|ExposureMask|EnterWindowMask | LeaveWindowMask);
	XSelectInput(RMan.display, Scroll.win_down2, ButtonPressMask|ExposureMask|EnterWindowMask | LeaveWindowMask);
	XSelectInput(RMan.display, Scroll.scrbar_box, ButtonPressMask|ButtonMotionMask|ButtonReleaseMask);
	XSelectInput(RMan.display, MenuWin.exit, ButtonPressMask|ExposureMask|EnterWindowMask | LeaveWindowMask);
	XSelectInput(RMan.display, MenuWin.title, ExposureMask);

	for ( i = 0 ; i <= MenuWin.XX*MenuWin.YY-1 ; i++){
		XSelectInput(RMan.display, MenuWin.sw[i], ButtonPressMask|ExposureMask|EnterWindowMask | LeaveWindowMask);
	}
}

CreateSetGC()
{
	char buffer[256];

	/*  GC   */
	Pager.gc = XCreateGC(RMan.display, Pager.window, 0, 0);
	MenuWin.gc = XCreateGC(RMan.display, RMan.window_p, 0, 0);
	MenuWin.MenuRevGC= XCreateGC(RMan.display, RMan.window_p, 0, 0);
	MenuWin.TitlGC = XCreateGC(RMan.display, RMan.window_p, 0, 0);
	MenuWin.TitlRevGC= XCreateGC(RMan.display, RMan.window_p, 0, 0);
	Pager.BitmGC = XCreateGC(RMan.display, RMan.window_p, 0, 0);

	/*  ForegroundΥ顼  */
	XSetForeground(RMan.display, Pager.gc, RMan.MainFG);	
	XSetForeground(RMan.display, MenuWin.gc, MenuWin.FG);	
	XSetForeground(RMan.display, MenuWin.MenuRevGC, MenuWin.BG);	
	XSetForeground(RMan.display, MenuWin.TitlGC, MenuWin.TitlFG);	
	XSetForeground(RMan.display, MenuWin.TitlRevGC, MenuWin.TitlBG);	
	XSetForeground(RMan.display, Pager.BitmGC, RMan.BitmFG);	

	XSetBackground(RMan.display, Pager.BitmGC, RMan.MainBG);
	XSetBackground(RMan.display, Pager.gc, RMan.MainBG);

	XSetPlaneMask(RMan.display, Pager.gc, RMan.PlaneMask);
}


SetWinMan(int argc, char *argv[])
{
	XSizeHints		*size_hints;
	XWMHints		wmh;
	XTextProperty	text_prop;

	/* Window Manager ؤ */
	size_hints = XAllocSizeHints();
	size_hints->min_width  = EXT_WID * (1+MenuWin.YY);
	size_hints->min_height = MENP_HEIT+Scroll.ScrlBoxHeit+UP1_HEIT+UP2_HEIT+DOWN1_HEIT+DOWN2_HEIT+5;
	size_hints->height_inc = Pager.SIZE_Y;
	size_hints->base_height= WIN_Y+2;
	size_hints->width_inc  = Pager.SIZE_X;
	size_hints->base_width = Scroll.ScrlWid+2;

	size_hints->flags      = PMinSize|PResizeInc|PBaseSize;
	XStringListToTextProperty(&RMan.winname, 1, &text_prop);
	XSetWMProperties(RMan.display, RMan.window_p, &text_prop, &text_prop, argv, argc, size_hints, NULL, NULL);

	wmh.flags = IconPixmapHint;
	wmh.icon_pixmap = RMan.IconPixmap;
	XSetWMHints(RMan.display, RMan.window_p, &wmh);
}

ReadConfigFile2(cfgname, search_name, file_last_no, titlemes)
char	*cfgname;
char	*search_name;
char	*file_last_no;
char	*titlemes;
{
	FILE	*cfp;
	int		i, type;
	char	buf1[81];
	char	dirbuf[81], *dir = (char *) &dirbuf[0];

	/* config fileΥץ */
	if (NULL == (cfp = fopen(cfgname, "rt"))){
		return;
	}

	/* config fileread */
	while (NULL != fgets(buf1, 81, cfp)){
		if (!strncmp(search_name, buf1, strlen(search_name))){
			break;
		}
	}
	fgets(titlemes, 81, cfp);
	fscanf(cfp, "%s", buf1);
	if (NULL == getenv(buf1)){
		fprintf(stderr, "\n󥦥ɥ鵯ưƲ.\n");
		exit(0);
	}
	strcpy(dir, (char *)getenv(buf1));
	strcat(dir, "/");

	i = 0;
	while (EOF != fscanf(cfp, "%d %s",&type, buf1))
	{
		if ((Menu[i].type = type) == 2) break;
		strcpy(Menu[i].name, buf1); 
		strcpy(Menu[i].title, fgets(buf1, 81, cfp)+1);
		i++;
	}
	*file_last_no = i-1;

	for ( i = 0 ; i <= *file_last_no ; i++ ){
		if (Menu[i].name[0] == '/'){ 
			strcpy(FSet[i].filename, Menu[i].name);
		} else{
			strcpy(FSet[i].filename, dir);
			strcat(FSet[i].filename, Menu[i].name);
		}
		FSet[i].file_table = 1;
		FSet[i].file_pos = 0;
	}
	for ( i = *file_last_no+1 ; i <= 19 ; i++ ){
		FSet[i].file_table = 0;
	}
	fclose(cfp);
}

SetColor()
{
	XColor			cc;
	unsigned long	plane[2], pixel[1];
	int				flags = DoRed | DoGreen | DoBlue;
	Colormap		dcm;

	/*  ץ饤١ȥ顼Υ  */
	dcm = DefaultColormap(RMan.display, 0);
	XAllocColorCells(RMan.display, dcm, True, plane, 2, pixel, 1);

	XStoreNamedColor(RMan.display, dcm, RMan.MainFGName, pixel[0]|plane[0], flags);
	XStoreNamedColor(RMan.display, dcm, RMan.MainFGName, pixel[0]|plane[0]|plane[1], flags);
	RMan.MainFG = pixel[0]|plane[0];
	RMan.PlaneMask = plane[0];

	XStoreNamedColor(RMan.display, dcm, RMan.BitmFGName, pixel[0]|plane[1], flags);
	RMan.BitmFG = pixel[0]|plane[1];

	XAllocNamedColor(RMan.display, dcm, RMan.MenuFGName, &cc, &cc);
	MenuWin.FG = cc.pixel;

	XAllocNamedColor(RMan.display, dcm, RMan.TitlFGName, &cc, &cc);
	MenuWin.ExitFG = MenuWin.TitlFG = cc.pixel;

	XAllocNamedColor(RMan.display, dcm, RMan.ScrlFGName, &cc, &cc);
	Scroll.ScrlFG = cc.pixel;
	
	XStoreNamedColor(RMan.display, dcm, RMan.MainBGName, pixel[0], flags);
	RMan.MainBG = pixel[0];
	
	XAllocNamedColor(RMan.display, dcm, RMan.MenuBGName, &cc, &cc);
	MenuWin.BG = cc.pixel;
	
	XAllocNamedColor(RMan.display, dcm, RMan.TitlBGName, &cc, &cc);
	MenuWin.ExitBG = MenuWin.TitlBG = cc.pixel;
	
	XAllocNamedColor(RMan.display, dcm, RMan.ScrlBGName, &cc, &cc);
	Scroll.ScrlBG = cc.pixel;

	free(RMan.MainFGName);
	free(RMan.MainBGName);
	free(RMan.MenuFGName);
	free(RMan.MenuBGName);
	free(RMan.TitlFGName);
	free(RMan.TitlBGName);
	free(RMan.ScrlFGName);
	free(RMan.ScrlBGName);
	free(RMan.BitmFGName);
}

Main(Display *display, struct PAGER *Pager, struct SCROLL *Scroll, struct MENUWIN *MenuWin, XEvent *event, struct MENU *Menu, struct FileSet *FSet, char *rootcfgname, struct RMAN *RMan)
{
	int		no;

	if (event->type == ClientMessage){
		if (event->xclient.message_type == XInternAtom(display, "Main-Exit", False)){
			exit(0);
		}
		if (event->xclient.message_type == XInternAtom(display, "Main-ChangeText", False)){
			no = event->xclient.data.l[0];

			if (FSet[no].file_table != 1){
				Bell(display, Pager->window, Pager->BELL);
				return;
			}
			if (Menu[no].type == 1){
				ReadConfigFile2(rootcfgname, Menu[no].name, &(MenuWin->file_last_no), MenuWin->titlemes);
				MenuWin->file_no = 0;
				Pager->pos = 0;
				SendMenuAllDraw(display, MenuWin->sw[0]);
			} else{
				FSet[MenuWin->file_no].file_pos = Pager->pos;
				MenuWin->file_no = no;
				SendMenuAllDraw(display, MenuWin->sw[0]);
			}
			Initialize(display, Pager, Scroll, MenuWin, RMan, Menu, FSet);
			return;
		}
	}
}

